/* Copyright (c) 2010-2011, Code Aurora Forum. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above
      copyright notice, this list of conditions and the following
      disclaimer in the documentation and/or other materials provided
      with the distribution.
    * Neither the name of Code Aurora Forum, Inc. nor the names of its
      contributors may be used to endorse or promote products derived
      from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef SP0A28_H
#define SP0A28_H
#include <linux/types.h>
#include <mach/board.h>

#define INVMASK(v)  (0xff-v)
#define SP0A28Core_WritePREG(pTbl)     SP0A28_WritePRegs(pTbl,sizeof(pTbl)/sizeof(pTbl[0]))

struct reg_addr_val_pair_struct {
	uint8_t	reg_addr;
	uint8_t	reg_val;
};

enum sp0a28_test_mode_t {
	TEST_OFF,
	TEST_1,
	TEST_2,
	TEST_3
};

enum sp0a28_resolution_t {
	QTR_SIZE,
	FULL_SIZE,
	INVALID_SIZE
};

enum sp0a28_setting {
	RES_PREVIEW,
	RES_CAPTURE
};
enum sp0a28_reg_update {
	/* Sensor egisters that need to be updated during initialization */
	REG_INIT,
	/* Sensor egisters that needs periodic I2C writes */
	UPDATE_PERIODIC,
	/* All the sensor Registers will be updated */
	UPDATE_ALL,
	/* Not valid update */
	UPDATE_INVALID
};

/*OV SENSOR SCCB*/
typedef struct {
	uint8_t addr;
	uint8_t data;
	//uint8_t mask;
} SP0A28_WREG, *PSP0A28_WREG;
#define SP0A28_P0_0xdd	0x80
#define SP0A28_P0_0xde	0x80
//sharpness                          
#define SP0A28_P1_0xe8	0x20//10//;sharp_fac_pos_outdoor
#define SP0A28_P1_0xec	0x30//20//;sharp_fac_neg_outdoor
#define SP0A28_P1_0xe9	0x10//0a//;sharp_fac_pos_nr
#define SP0A28_P1_0xed	0x30//20//;sharp_fac_neg_nr
#define SP0A28_P1_0xea	0x10//08//;sharp_fac_pos_dummy
#define SP0A28_P1_0xef	0x20//18//;sharp_fac_neg_dummy
#define SP0A28_P1_0xeb	0x10//08//;sharp_fac_pos_low
#define SP0A28_P1_0xf0	0x10//18//;sharp_fac_neg_low 
//saturation
#define SP0A28_P0_0xd3	0x90
#define SP0A28_P0_0xd4	0x90
#define SP0A28_P0_0xd6	0x70
#define SP0A28_P0_0xd7	0x60
#define SP0A28_P0_0xd8	0x90
#define SP0A28_P0_0xd9	0x90
#define SP0A28_P0_0xda	0x70
#define SP0A28_P0_0xdb	0x60
                                
//Ae target
#define SP0A28_P0_0xf7	0x78//0x80
#define SP0A28_P0_0xf8	0x70//0x78
#define SP0A28_P0_0xf9	0x78//0x80 
#define SP0A28_P0_0xfa	0x70//0x78 







 
/*  96MHz PCLK @ 24MHz MCLK */
struct reg_addr_val_pair_struct sp0a28_init_settings_array[] = { 
{0xfd,0x01},
{0x7c,0x6c},
{0xfd,0x00},
{0x1C,0x00},
{0x32,0x00},
{0x0e,0x00},
{0x0f,0x40},
{0x10,0x40},
{0x11,0x10},
{0x12,0xa0},
{0x13,0x40},
{0x15,0x00},
{0x16,0x08},//add
{0x1A,0x37},
{0x1B,0x17},
{0x1C,0x2f},  //close yuv
{0x1d,0x00},
{0x1E,0x57},
{0x21,0x36},//2f
{0x22,0x12},
{0x24,0x80},
{0x25,0x02},
{0x26,0x03},
{0x27,0xeb},
{0x28,0x5f},
{0x2f,0x01},
{0x5f,0x02},
{0xfb,0x33}, 
{0xe7,0x03},
{0xe7,0x00},
//ae setting
{0xfd,0x00},
{0x03,0x01},
{0x04,0x2c},
{0x05,0x00},
{0x06,0x00},
{0x09,0x01},
{0x0a,0x54},
{0xf0,0x64},
{0xf1,0x00},
{0xfd,0x01},
{0x90,0x0c},
{0x92,0x01},
{0x98,0x64},
{0x99,0x00},
{0x9a,0x01},
{0x9b,0x00},
//Status
{0xfd,0x01},
{0xce,0xb0},
{0xcf,0x04},
{0xd0,0xb0},
{0xd1,0x04},
{0xfd,0x00},

{0xfd,0x01},
{0xc4,0x6c},
{0xc5,0x7c},
{0xca,0x30},
{0xcb,0x45},
{0xcc,0x60},//0x70
{0xcd,0x60},//0x70
//DP
  {0xfd,0x00},
  {0x45,0x00},
  {0x46,0x99},
  {0x79,0xff},
  {0x7a,0xff},
  {0x7b,0x10},
  {0x7c,0x10},

//lsc  for SX5044module
{0xfd,0x01},
{0x35,0x0e},//0x0a
{0x36,0x14},//0x20
{0x37,0x20},
{0x38,0x1c},//0x22
{0x39,0x09},//0x06
{0x3a,0x10},//0x1a
{0x3b,0x19},
{0x3c,0x1a},//0x18
{0x3d,0x08},//0x09
{0x3e,0x10},//0x1c
{0x3f,0x14},//0x18
{0x40,0x22},
{0x41,0x0a},//0x00
{0x42,0x00},//0x18
{0x43,0x0a},//0x02
{0x44,0xfc},
{0x45,0x00},
{0x46,0xfe},//0x14
{0x47,0x00},
{0x48,0xf8},
{0x49,0x00},//0xfc
{0x4a,0xf8},//0x12
{0x4b,0x00},
{0x4c,0xf2},
{0xfd,0x00},
{0xa1,0x20},
{0xa2,0x20},
{0xa3,0x20},
{0xa4,0xff},  
//smooth  
{0xfd,0x01},
{0xde,0x0f},
{0xfd,0x00},
//ͨƽֵ	
{0x57,0x04},	//	;raw_dif_thr_outdoor
{0x58,0x0a},//0x0a	// ;raw_dif_thr_normal
{0x56,0x10},//0x10	// ;raw_dif_thr_dummy
{0x59,0x10},	// ;raw_dif_thr_lowlight
//GrGbƽֵ
{0x89,0x04},	//;raw_grgb_thr_outdoor 
{0x8a,0x0a}, //;raw_grgb_thr_normal  
{0x9c,0x10}, //;raw_grgb_thr_dummy   
{0x9d,0x10}, //;raw_grgb_thr_lowlight
//Gr\Gb֮ƽǿ
{0x81,0xe0}, //   ;raw_gflt_fac_outdoor
{0x82,0xa0}, //;80;raw_gflt_fac_normal
{0x83,0x80}, //   ;raw_gflt_fac_dummy
{0x84,0x80}, //   ;raw_gflt_fac_lowlight
//GrGbͨƽǿ  
{0x85,0xe0}, //;raw_gf_fac_outdoor  
{0x86,0xa0}, //;raw_gf_fac_normal  
{0x87,0x80}, //;raw_gf_fac_dummy   
{0x88,0x80}, //;raw_gf_fac_lowlight
//RBƽǿ  
{0x5a,0xff},		//;raw_rb_fac_outdoor
{0x5b,0xc0}, 		//;raw_rb_fac_normal
{0x5c,0xa0}, 	  //;raw_rb_fac_dummy
{0x5d,0xa0}, 	  //;raw_rb_fac_lowlight
//adt ƽֵӦ
{0xa7,0xff},
{0xa8,0xff},	//;0x2f
{0xa9,0xff},	//;0x2f
{0xaa,0xff},	//;0x2f
//dem_morie_thr ȥĦ
{0x9e,0x10},
//sharpen 
{0xfd,0x01},	//
{0xe2,0x30},	//	;sharpen_y_base
{0xe4,0xa0},	//	;sharpen_y_max
{0xe5,0x08},	// ;rangek_neg_outdoor
{0xd3,0x10},	// ;rangek_pos_outdoor   
{0xd7,0x08},	// ;range_base_outdoor   
{0xe6,0x08},//0x08	// ;rangek_neg_normal
{0xd4,0x10},//0x10	// ;rangek_pos_normal 
{0xd8,0x08},	// ;range_base_normal  
{0xe7,0x10},	// ;rangek_neg_dummy
{0xd5,0x10},	// ;rangek_pos_dummy
{0xd9,0x10},	// ;range_base_dummy 
{0xd2,0x10},	// ;rangek_neg_lowlight
{0xd6,0x10},	// ;rangek_pos_lowlight
{0xda,0x10},	// ;range_base_lowlight
{0xe8,SP0A28_P1_0xe8},//0x20	//;sharp_fac_pos_outdoor
{0xec,SP0A28_P1_0xec},//0x30	//;sharp_fac_neg_outdoor
{0xe9,SP0A28_P1_0xe9},//0x10	//;sharp_fac_pos_nr
{0xed,SP0A28_P1_0xed},//0x30	//;sharp_fac_neg_nr
{0xea,SP0A28_P1_0xea},//0x10	//;sharp_fac_pos_dummy
{0xef,SP0A28_P1_0xef},//0x20	//;sharp_fac_neg_dummy
{0xeb,SP0A28_P1_0xeb},//0x10	//;sharp_fac_pos_low
{0xf0,SP0A28_P1_0xf0},//0x20	//;sharp_fac_neg_low 
//CCM
{0xfd,0x01},	//
{0xa0,0x80},	//;8c;80;80;80(ɫӽɫ)
{0xa1,0x00},	//;0c;00;0 ;0 
{0xa2,0x00},	//;e8;00;0 ;0 
{0xa3,0xf6},	//;ec;ff;f2;f3;f0
{0xa4,0x99},	//;99;9a;8e;a6
{0xa5,0xf2},	//;fb;e7;0 ;ea
{0xa6,0x0d},	//;0d;0c;0 ;0 
{0xa7,0xda},	//;da;da;e6;e6
{0xa8,0x98},	//;98;9a;9a;9a
{0xa9,0x00},	//;30;00;0 ;0 
{0xaa,0x33},	//;33;33;3 ;33
{0xab,0x0c},	//;0c;0c;c ;c 
{0xfd,0x00},	//;00	 
//gamma  
{0xfd,0x00},	//00
{0x8b,0x00},	//0       
{0x8c,0x0f},	//12
{0x8d,0x21},	//1f
{0x8e,0x3b},	//31
{0x8f,0x64},	//4c
{0x90,0x84},	//62
{0x91,0xa0},	//77
{0x92,0xb6},	//89
{0x93,0xc7},	//9b
{0x94,0xd2},	//a8
{0x95,0xda},	//b5
{0x96,0xe0},	//c0
{0x97,0xe6},	//ca
{0x98,0xea},	//d4
{0x99,0xef},	//dd
{0x9a,0xf4},	//e6
{0x9b,0xf7},	//ef
{0xfd,0x01},	//01
{0x8d,0xfb},	//f7
{0x8e,0xff},	//ff
{0xfd,0x00},	//00

/*//gamma ҽ׷ֲ  
{0xfd,0x00},	
{0x8b,0x00},	      
{0x8c,0x11},	
{0x8d,0x24},	
{0x8e,0x3f},	
{0x8f,0x64},	
{0x90,0x7f},	
{0x91,0x93},	
{0x92,0xa4},	
{0x93,0xb2},	
{0x94,0xbb},	
{0x95,0xc4},	
{0x96,0xcb},	
{0x97,0xd1},	
{0x98,0xd5},	
{0x99,0xdc},	
{0x9a,0xe2},	
{0x9b,0xe9},	
{0xfd,0x01},	
{0x8d,0xf2},	
{0x8e,0xff},	
{0xfd,0x00},	
*/
//awb for 
{0xfd,0x01},
{0x28,0xc4},
{0x29,0x9e},
{0x11,0x13},	
{0x12,0x13},
{0x2e,0x0d},	
{0x2f,0x0d},
{0x16,0x1c},
{0x17,0x1a},
{0x18,0x1a},	
{0x19,0x54},	
{0x1a,0xa9},  
{0x1b,0x97},
{0x2a,0xef},

 /*// awb for ǰ      
 {0xfd,0x01},    
 {0x11,0x08},    
 {0x12,0x08},    
 {0x2e,0x04},    
 {0x2f,0x04},    
 {0x16,0x1c},    
 {0x17,0x1a},    
 {0x18,0x16},    
 {0x19,0x54},    
 {0x1a,0x90},    
 {0x1b,0x9b},    
 {0x2a,0xef},    
 {0x2b,0x30},    
 {0x21,0x96},    
 {0x22,0x9a},    
*/
//AE;rpc 
{0xfd,0x00},
{0xe0,0x3a},//
{0xe1,0x2c},//24,
{0xe2,0x26},//
{0xe3,0x22},//
{0xe4,0x22},//
{0xe5,0x20},//
{0xe6,0x20},//
{0xe8,0x20},//19,
{0xe9,0x20},//19,
{0xea,0x20},//19,
{0xeb,0x1e},//18,
{0xf5,0x1e},//18,
{0xf6,0x1e},//18,
//ae min gain  
{0xfd,0x01},
{0x94,0x60},
{0x95,0x1e},//0x18
{0x9c,0x60},
{0x9d,0x1e},//0x18   
//ae target
{0xfd,0x00},
{0xed,SP0A28_P0_0xf7 + 0x04},//0x84 
{0xf7,SP0A28_P0_0xf7},		//0x80 
{0xf8,SP0A28_P0_0xf8},		//0x78 
{0xec,SP0A28_P0_0xf8 - 0x04},//0x74  
{0xef,SP0A28_P0_0xf9 + 0x04},//0x84
{0xf9,SP0A28_P0_0xf9},		//0x80
{0xfa,SP0A28_P0_0xfa},		//0x78
{0xee,SP0A28_P0_0xfa - 0x04},//0x74
//gray detect
{0xfd,0x01},
{0x30,0x40},
{0x31,0x10},
{0x32,0x20},
{0x33,0xef},
{0x34,0x02},
{0x4d,0x40},
{0x4e,0x15},
{0x4f,0x13},
//saturation
{0xfd,0x00},
{0xbe,0xaa},  
{0xc0,0xff},
{0xc1,0xff},
{0xd3,SP0A28_P0_0xd3},
{0xd4,SP0A28_P0_0xd4}, 
{0xd6,SP0A28_P0_0xd6},
{0xd7,SP0A28_P0_0xd7},
{0xd8,SP0A28_P0_0xd8},
{0xd9,SP0A28_P0_0xd9}, 
{0xda,SP0A28_P0_0xda},
{0xdb,SP0A28_P0_0xdb},
//heq   
{0xfd,0x00},
{0xdc,0x00},	//;heq_offset
{0xdd,0x80},	//;ku
{0xde,0x80},	//;90;kl
{0xdf,0x80},	//;heq_mean
//YCnr  
{0xfd,0x00},
{0xc2,0x08},	//Ynr_thr_outdoor
{0xc3,0x08},	//Ynr_thr_normal
{0xc4,0x08},	//Ynr_thr_dummy
{0xc5,0x10},	//Ynr_thr_lowlight
{0xc6,0x80},	//cnr_thr_outdoor
{0xc7,0x80},	//cnr_thr_normal  
{0xc8,0x80},	//cnr_thr_dummy   
{0xc9,0x80},	//cnr_thr_lowlight  
//auto lum
{0xfd,0x00},
{0xb2,0x18},
{0xb3,0x1f},
{0xb4,0x30},
{0xb5,0x45},
//func enable
{0xfd,0x00},
{0x32,0x0d},
{0x34,0x7e},// 1e
{0x33,0xef},
{0x35,0x40},
};

// Exposure Compensation
SP0A28_WREG sp0a28_exposure_compensation_lv0_tbl[]=
{
	//@@ +2EV
	{0xfd,0x00},
	{0xdc,0x20},
	//{0x32,0x08},
	//{0x24,0x60},
};

SP0A28_WREG sp0a28_exposure_compensation_lv1_tbl[]=
{
	//@@ +1EV
	{0xfd,0x00},
	{0xdc,0x10},
	//{0x32,0x08},
	//{0x24,0x50},
};

SP0A28_WREG sp0a28_exposure_compensation_lv2_default_tbl[]=
{
	//@@ default
	{0xfd,0x00},
	{0xdc,0x00},
	//{0x32,0x08},
	//{0x24,0x40},
};

SP0A28_WREG sp0a28_exposure_compensation_lv3_tbl[]=
{
	//@@ -1EV
	{0xfd,0x00},
	{0xdc,0xf0},	
	//{0x32,0x08},
	//{0x24,0x30},
};

SP0A28_WREG sp0a28_exposure_compensation_lv4_tbl[]=
{
	//@@ -2EV
	{0xfd,0x00},
	{0xdc,0xe0},		
	//{0x32,0x08},
	//{0x24,0x20},
};

SP0A28_WREG sp0a28_antibanding_off_tbl[] =
{
	{0xfd, 0x00},
//	{0x32, 0x08},
};

SP0A28_WREG sp0a28_antibanding_auto_tbl[] =
{
	//ae setting
        {0xfd,0x00},
        {0x03,0x01},
        {0x04,0x2c},
        {0x05,0x00},
        {0x06,0x00},
        {0x09,0x01},
	{0x0a,0x54}, 
	{0xf0,0x64}, 
	{0xf1,0x00}, 
	{0xfd,0x01}, 
	{0x90,0x0c}, 
	{0x92,0x01}, 
	{0x98,0x64}, 
        {0x99,0x00},
        {0x9a,0x01},
        {0x9b,0x00},
	 //Status   
	{0xfd,0x01},
	{0xce,0xb0}, 
	{0xcf,0x04}, 
	{0xd0,0xb0}, 
        {0xd1,0x04},
        {0xfd,0x00},
};

SP0A28_WREG sp0a28_antibanding_50z_tbl[] =
{
	//Band 50Hz 8-20fps
        {0xfd,0x00},
        {0x03,0x01},
        {0x04,0x2c},
        {0x05,0x00},
        {0x06,0x00},
	{0x09,0x01}, 
	{0x0a,0x54}, 
	{0xf0,0x64}, 
	{0xf1,0x00}, 
	{0xfd,0x01}, 
	{0x90,0x0c}, 
	{0x92,0x01}, 
	{0x98,0x64}, 
        {0x99,0x00},
        {0x9a,0x01},
        {0x9b,0x00},
	 //Status   
	{0xfd,0x01},
	{0xce,0xb0},
	{0xcf,0x04}, 
	{0xd0,0xb0}, 
        {0xd1,0x04},
        {0xfd,0x00},
};

SP0A28_WREG sp0a28_antibanding_60z_tbl[] =
{
	//Band 60Hz 8-20fps  
	{0xfd,0x00},
        {0x03,0x00},
        {0x04,0xfc},
        {0x05,0x00},
        {0x06,0x00},
        {0x09,0x01},
	{0x0a,0x4a}, 
	{0xf0,0x54}, 
	{0xf1,0x00}, 
	{0xfd,0x01}, 
	{0x90,0x0f},
	{0x92,0x01}, 
	{0x98,0x54}, 
        {0x99,0x00},
        {0x9a,0x01},
        {0x9b,0x00},
	  //Status 
	{0xfd,0x01},
	{0xce,0xec}, 
	{0xcf,0x04},
	{0xd0,0xec}, 
        {0xd1,0x04},
        {0xfd,0x00},
};

//Saturation
SP0A28_WREG sp0a28_saturation_lv0_tbl[] =
{
	//Saturation level 0
	{0xfd, 0x00}, 
	{0xd3, SP0A28_P0_0xd3 - 0x40}, 
	{0xd4, SP0A28_P0_0xd4 - 0x40}, 
	{0xd6, SP0A28_P0_0xd6 - 0x40}, 
	{0xd7, SP0A28_P0_0xd7 - 0x40},
	{0xd8, SP0A28_P0_0xd8 - 0x40}, 
	{0xd9, SP0A28_P0_0xd9 - 0x40}, 
	{0xda, SP0A28_P0_0xda - 0x40}, 
	{0xdb, SP0A28_P0_0xdb - 0x40}, 
};

SP0A28_WREG sp0a28_saturation_lv1_tbl[] =
{
	//Saturation level 1
	{0xfd, 0x00}, 
	{0xd3, SP0A28_P0_0xd3}, 
	{0xd4, SP0A28_P0_0xd4 - 0x30}, 
	{0xd6, SP0A28_P0_0xd6 - 0x30},
	{0xd7, SP0A28_P0_0xd7 - 0x30}, 
	{0xd8, SP0A28_P0_0xd8 - 0x30}, 
	{0xd9, SP0A28_P0_0xd9 - 0x30}, 
	{0xda, SP0A28_P0_0xda - 0x30}, 
	{0xdb, SP0A28_P0_0xdb - 0x30}, 
};

SP0A28_WREG sp0a28_saturation_lv2_tbl[] =
{
	//Saturation level 2
	{0xfd, 0x00}, 
	{0xd3, SP0A28_P0_0xd3 - 0x20}, 
	{0xd4, SP0A28_P0_0xd4 - 0x20}, 
	{0xd6, SP0A28_P0_0xd6 - 0x20}, 
	{0xd7, SP0A28_P0_0xd7 - 0x20}, 
	{0xd8, SP0A28_P0_0xd8 - 0x20}, 
	{0xd9, SP0A28_P0_0xd9 - 0x20}, 
	{0xda, SP0A28_P0_0xda - 0x20}, 
	{0xdb, SP0A28_P0_0xdb - 0x20}, 
};

SP0A28_WREG sp0a28_saturation_lv3_tbl[] =
{
	//Saturation level 3
	{0xfd, 0x00}, 
	{0xd3, SP0A28_P0_0xd3 - 0x10},
	{0xd4, SP0A28_P0_0xd4 - 0x10},
	{0xd6, SP0A28_P0_0xd6 - 0x10}, 
	{0xd7, SP0A28_P0_0xd7 - 0x10}, 
	{0xd8, SP0A28_P0_0xd8 - 0x10}, 
	{0xd9, SP0A28_P0_0xd9 - 0x10}, 
	{0xda, SP0A28_P0_0xda - 0x10}, 
	{0xdb, SP0A28_P0_0xdb - 0x10}, 

};

SP0A28_WREG sp0a28_saturation_default_lv4_tbl[] =
{
	//Saturation level 4 (default)  
	{0xfd, 0x00}, 
	{0xd3, SP0A28_P0_0xd3}, 
	{0xd4, SP0A28_P0_0xd4}, 
	{0xd6, SP0A28_P0_0xd6}, 
	{0xd7, SP0A28_P0_0xd7},
	{0xd8, SP0A28_P0_0xd8}, 
	{0xd9, SP0A28_P0_0xd9},
	{0xda, SP0A28_P0_0xda}, 
	{0xdb, SP0A28_P0_0xdb}, 

};

SP0A28_WREG sp0a28_saturation_lv5_tbl[] =
{
	//Saturation level 5 
	{0xfd, 0x00},
	{0xd3, SP0A28_P0_0xd3 + 0x10}, 
	{0xd4, SP0A28_P0_0xd4 + 0x10},
	{0xd6, SP0A28_P0_0xd6 + 0x10}, 
	{0xd7, SP0A28_P0_0xd7 + 0x10}, 
	{0xd8, SP0A28_P0_0xd8 + 0x10}, 
	{0xd9, SP0A28_P0_0xd9 + 0x10}, 
	{0xda, SP0A28_P0_0xda + 0x10}, 
	{0xdb, SP0A28_P0_0xdb + 0x10}, 
};

SP0A28_WREG sp0a28_saturation_lv6_tbl[] =
{
	//Saturation level 6
	{0xfd, 0x00}, 
	{0xd3, SP0A28_P0_0xd3 + 0x20}, 
	{0xd4, SP0A28_P0_0xd4 + 0x20},
	{0xd6, SP0A28_P0_0xd6 + 0x20},
	{0xd7, SP0A28_P0_0xd7 + 0x20}, 
	{0xd8, SP0A28_P0_0xd8 + 0x20}, 
	{0xd9, SP0A28_P0_0xd9 + 0x20}, 
	{0xda, SP0A28_P0_0xda + 0x20}, 
	{0xdb, SP0A28_P0_0xdb + 0x20}, 
};

SP0A28_WREG sp0a28_saturation_lv7_tbl[] =
{
	//Saturation level 7
	{0xfd, 0x00}, 
	{0xd3, SP0A28_P0_0xd3 + 0x30},
	{0xd4, SP0A28_P0_0xd4 + 0x30},
	{0xd6, SP0A28_P0_0xd6 + 0x30}, 
	{0xd7, SP0A28_P0_0xd7 + 0x30}, 
	{0xd8, SP0A28_P0_0xd8 + 0x30}, 
	{0xd9, SP0A28_P0_0xd9 + 0x30}, 
	{0xda, SP0A28_P0_0xda + 0x30}, 
	{0xdb, SP0A28_P0_0xdb + 0x30}, 
};

SP0A28_WREG sp0a28_saturation_lv8_tbl[] =
{
	//Saturation level 8
	{0xfd, 0x00}, 
	{0xd3, SP0A28_P0_0xd3 + 0x40}, 
	{0xd4, SP0A28_P0_0xd4 + 0x40},
	{0xd6, SP0A28_P0_0xd6 + 0x40}, 
	{0xd7, SP0A28_P0_0xd7 + 0x40}, 
	{0xd8, SP0A28_P0_0xd8 + 0x40}, 
	{0xd9, SP0A28_P0_0xd9 + 0x40}, 
	{0xda, SP0A28_P0_0xda + 0x40}, 
	{0xdb, SP0A28_P0_0xdb + 0x40}, 
};

SP0A28_WREG sp0a28_saturation_lv9_tbl[] =
{
	//Saturation level 9
	{0xfd, 0x00}, 
	{0xd3, SP0A28_P0_0xd3 + 0x50}, 
	{0xd4, SP0A28_P0_0xd4 + 0x50}, 
	{0xd6, SP0A28_P0_0xd6 + 0x50}, 
	{0xd7, SP0A28_P0_0xd7 + 0x50}, 
	{0xd8, SP0A28_P0_0xd8 + 0x50}, 
	{0xd9, SP0A28_P0_0xd9 + 0x50}, 
	{0xda, SP0A28_P0_0xda + 0x50}, 
	{0xdb, SP0A28_P0_0xdb + 0x50},
};

SP0A28_WREG sp0a28_saturation_lv10_tbl[] =
{
	//Saturation level 10
	{0xfd, 0x00}, 
	{0xd3, SP0A28_P0_0xd3 + 0x60}, 
	{0xd4, SP0A28_P0_0xd4 + 0x60}, 
	{0xd6, SP0A28_P0_0xd6 + 0x60},
	{0xd7, SP0A28_P0_0xd7 + 0x60}, 
	{0xd8, SP0A28_P0_0xd8 + 0x60}, 
	{0xd9, SP0A28_P0_0xd9 + 0x60}, 
	{0xda, SP0A28_P0_0xda + 0x60},
	{0xdb, SP0A28_P0_0xdb + 0x60}, 
};


//EFFECT
SP0A28_WREG sp0a28_effect_normal_tbl[] =
{
	{0xfd, 0x00},
	{0x62, 0x00},
	{0x63, 0x80},
	{0x64, 0x80},
};

SP0A28_WREG sp0a28_effect_mono_tbl[] =
{
	{0xfd, 0x00},
	{0x62, 0x20},
	{0x63, 0x80},
	{0x64, 0x80},

};

SP0A28_WREG sp0a28_effect_bw_tbl[] =
{
	{0xfd, 0x00},
	{0x62, 0x08},
	{0x63, 0x80},
	{0x64, 0x80},
};

SP0A28_WREG sp0a28_effect_sepia_tbl[] =
{
	{0xfd, 0x00},
	{0x62, 0x10},
	{0x63, 0xc0},
	{0x64, 0x20},
};

SP0A28_WREG sp0a28_effect_bluish_tbl[] =
{
	{0xfd, 0x00},
	{0x62, 0x10},
	{0x63, 0x20},
	{0x64, 0xd0},
};

SP0A28_WREG sp0a28_effect_reddish_tbl[] =
{
	{0xfd, 0x00},
	{0x62, 0x10},
	{0x63, 0xb0},
	{0x64, 0x90},
};

SP0A28_WREG sp0a28_effect_greenish_tbl[] =
{
	{0xfd, 0x00},
	{0x62, 0x10},
	{0x63, 0x60},
	{0x64, 0x60},
};

SP0A28_WREG sp0a28_effect_negative_tbl[] =
{
	{0xfd, 0x00},
	{0x62, 0x04},
	{0x63, 0x80},
	{0x64, 0x80},
};

//Contrast
SP0A28_WREG sp0a28_contrast_lv0_tbl[] =
{
	//Contrast -4
	{0xfd, 0x00},
	{0xdd, SP0A28_P0_0xdd - 0x20},
	{0xde, SP0A28_P0_0xde - 0x20},
};


SP0A28_WREG sp0a28_contrast_lv1_tbl[] =
{
	//Contrast -3
	{0xfd, 0x00},
	{0xdd, SP0A28_P0_0xdd - 0x18},
	{0xde, SP0A28_P0_0xde - 0x18},
};

SP0A28_WREG sp0a28_contrast_lv2_tbl[] =
{
	//Contrast -2
	{0xfd, 0x00},
	{0xdd, SP0A28_P0_0xdd - 0x10},
	{0xde, SP0A28_P0_0xde - 0x10},
};

SP0A28_WREG sp0a28_contrast_lv3_tbl[] =
{
	//Contrast -1
	{0xfd, 0x00},
	{0xdd, SP0A28_P0_0xdd - 0x08},
	{0xde, SP0A28_P0_0xde - 0x08},
};

SP0A28_WREG sp0a28_contrast_default_lv4_tbl[] =
{
	//Contrast 0
	{0xfd, 0x00},
	{0xdd, SP0A28_P0_0xdd},
	{0xde, SP0A28_P0_0xde},
};

SP0A28_WREG sp0a28_contrast_lv5_tbl[] =
{
	//Contrast 1
	{0xfd, 0x00},
	{0xdd, SP0A28_P0_0xdd + 0x08},
	{0xde, SP0A28_P0_0xde + 0x08},
};

SP0A28_WREG sp0a28_contrast_lv6_tbl[] =
{
	//Contrast 2
	{0xfd, 0x00},
	{0xdd, SP0A28_P0_0xdd + 0x10},
	{0xde, SP0A28_P0_0xde + 0x10},
};

SP0A28_WREG sp0a28_contrast_lv7_tbl[] =
{
	//Contrast 3
	{0xfd, 0x00},
	{0xdd, SP0A28_P0_0xdd + 0x18},
	{0xde, SP0A28_P0_0xde + 0x18},
};

SP0A28_WREG sp0a28_contrast_lv8_tbl[] =
{
	//Contrast 4
	{0xfd, 0x00},
	{0xdd, SP0A28_P0_0xdd + 0x20},
	{0xde, SP0A28_P0_0xde + 0x20},
};

SP0A28_WREG sp0a28_contrast_lv9_tbl[] =
{
	//Contrast 5
	{0xfd, 0x00},
	{0xdd, SP0A28_P0_0xdd + 0x28},
	{0xde, SP0A28_P0_0xde + 0x28},
};

SP0A28_WREG sp0a28_contrast_lv10_tbl[] =
{
	//Contrast 6
	{0xfd, 0x00},
	{0xdd, SP0A28_P0_0xdd + 0x30},
	{0xde, SP0A28_P0_0xde + 0x30},
};



//Sharpness
SP0A28_WREG sp0a28_sharpness_lv0_tbl[] =
{
//Sharpness 0
	{0xfd, 0x01},
	{0xe8, SP0A28_P1_0xe8 - 0x08},
	{0xec, SP0A28_P1_0xec - 0x08},
	{0xe9, SP0A28_P1_0xe9 - 0x08},
	{0xed, SP0A28_P1_0xed - 0x08},
	{0xea, SP0A28_P1_0xea - 0x08},
	{0xef, SP0A28_P1_0xef - 0x08},
	{0xeb, SP0A28_P1_0xeb - 0x08},
	{0xf0, SP0A28_P1_0xf0 - 0x08},
};
SP0A28_WREG sp0a28_sharpness_lv1_tbl[] =
{
//Sharpness 1
	{0xfd, 0x01},
	{0xe8, SP0A28_P1_0xe8 - 0x04},
	{0xec, SP0A28_P1_0xec - 0x04},
	{0xe9, SP0A28_P1_0xe9 - 0x04},
	{0xed, SP0A28_P1_0xed - 0x04},
	{0xea, SP0A28_P1_0xea - 0x04},
	{0xef, SP0A28_P1_0xef - 0x04},
	{0xeb, SP0A28_P1_0xeb - 0x04},
	{0xf0, SP0A28_P1_0xf0 - 0x04},
};
SP0A28_WREG sp0a28_sharpness_default_lv2_tbl[] =
{
//Sharpness Auto (Default)
	{0xfd, 0x01},
	{0xe8, SP0A28_P1_0xe8},
	{0xec, SP0A28_P1_0xec},
	{0xe9, SP0A28_P1_0xe9},
	{0xed, SP0A28_P1_0xed},
	{0xea, SP0A28_P1_0xea},
	{0xef, SP0A28_P1_0xef},
	{0xeb, SP0A28_P1_0xeb},
	{0xf0, SP0A28_P1_0xf0},
};
SP0A28_WREG sp0a28_sharpness_lv3_tbl[] =
{
//Sharpness 3
	{0xfd, 0x01},
	{0xe8, SP0A28_P1_0xe8 + 0x08},
	{0xec, SP0A28_P1_0xec + 0x08},
	{0xe9, SP0A28_P1_0xe9 + 0x08},
	{0xed, SP0A28_P1_0xed + 0x08},
	{0xea, SP0A28_P1_0xea + 0x08},
	{0xef, SP0A28_P1_0xef + 0x08},
	{0xeb, SP0A28_P1_0xeb + 0x08},
	{0xf0, SP0A28_P1_0xf0 + 0x08},
};
SP0A28_WREG sp0a28_sharpness_lv4_tbl[] =
{
//Sharpness 4
	{0xfd, 0x01},
	{0xe8, SP0A28_P1_0xe8 + 0x10},
	{0xec, SP0A28_P1_0xec + 0x10},
	{0xe9, SP0A28_P1_0xe9 + 0x10},
	{0xed, SP0A28_P1_0xed + 0x10},
	{0xea, SP0A28_P1_0xea + 0x10},
	{0xef, SP0A28_P1_0xef + 0x10},
	{0xeb, SP0A28_P1_0xeb + 0x10},
	{0xf0, SP0A28_P1_0xf0 + 0x10},
};
SP0A28_WREG sp0a28_sharpness_lv5_tbl[] =
{
//Sharpness 5
	{0xfd, 0x01},
	{0xe8, SP0A28_P1_0xe8 + 0x18},
	{0xec, SP0A28_P1_0xec + 0x18},
	{0xe9, SP0A28_P1_0xe9 + 0x18},
	{0xed, SP0A28_P1_0xed + 0x18},
	{0xea, SP0A28_P1_0xea + 0x18},
	{0xef, SP0A28_P1_0xef + 0x18},
	{0xeb, SP0A28_P1_0xeb + 0x18},
	{0xf0, SP0A28_P1_0xf0 + 0x18},
};
SP0A28_WREG sp0a28_sharpness_lv6_tbl[] =
{
//Sharpness 6
	{0xfd, 0x01},
	{0xe8, SP0A28_P1_0xe8 + 0x20},
	{0xec, SP0A28_P1_0xec + 0x20},
	{0xe9, SP0A28_P1_0xe9 + 0x20},
	{0xed, SP0A28_P1_0xed + 0x20},
	{0xea, SP0A28_P1_0xea + 0x20},
	{0xef, SP0A28_P1_0xef + 0x20},
	{0xeb, SP0A28_P1_0xeb + 0x20},
	{0xf0, SP0A28_P1_0xf0 + 0x20},
};

// ISO TYPE
SP0A28_WREG sp0a28_iso_type_auto[]=
{
	{0xfd, 0x00},
	//{0x32, 0x0d},
};

SP0A28_WREG sp0a28_iso_type_100[]=
{
	{0xfd, 0x00},
	//{0x32, 0x08},
	{0x24, 0x20},
};

SP0A28_WREG sp0a28_iso_type_200[]=
{
	{0xfd, 0x00},
	//{0x32, 0x08},
	{0x24, 0x30},

};

SP0A28_WREG sp0a28_iso_type_400[]=
{
	{0xfd, 0x00},
	//{0x32, 0x08},
	{0x24, 0x40},

};

SP0A28_WREG sp0a28_iso_type_800[]=
{
	{0xfd, 0x00},
	//{0x32, 0x08},
	{0x24, 0x50},

};

SP0A28_WREG sp0a28_iso_type_1600[]=
{
	{0xfd, 0x00},
	//{0x32, 0x08},
	{0x24, 0x60},

};

//Light Mode
SP0A28_WREG sp0a28_wb_auto[]=
{
	{0xfd, 0x01},
	{0x28, 0xc4},
	{0x29, 0x9e},
	{0xfd, 0x00},
	//{0x32, 0x0d},
};

SP0A28_WREG sp0a28_wb_fluorescent[]=
{
	//{0xfd, 0x00},
	//{0x32, 0x05},
	{0xfd, 0x01},
	{0x28, 0xb4},
	{0x29, 0xc4},
	{0xfd, 0x00},
};

SP0A28_WREG sp0a28_wb_incandescent[]=
{
	//{0xfd, 0x00},
	//{0x32, 0x05},
	{0xfd, 0x01},
	{0x28, 0x7b},
	{0x29, 0xd3},
	{0xfd, 0x00},
};

SP0A28_WREG sp0a28_wb_daylight[]=
{
	//{0xfd, 0x00},
	//{0x32, 0x05},
	{0xfd, 0x01},
	{0x28, 0xc1},
	{0x29, 0x88},
	{0xfd, 0x00},
};

SP0A28_WREG sp0a28_wb_cloudy[]=
{
	//{0xfd, 0x00},
	//{0x32, 0x05},
	{0xfd, 0x01},
	{0x28, 0xe2},
	{0x29, 0x82},
	{0xfd, 0x00},
};

#endif

